# 
# This file is to be processed by gnuplot.
# The data file(s) from PROCMON are read and
# procmon.ps is created.
# 
set output 'procmon.ps'
set terminal postscript portrait color 'Times-Roman' 10
set nomultiplot
#
# Plotting [Orig Data: %pTimeTot = % CPU Usage Total ([User+System]/Wall)] on a new page.
# 
set multiplot
set nokey
set grid x2tics ytics
set format x ''
set x2tics
set x2label 'Time (secs)'
set format x2 "%17f"
set  xrange [0:43.1486210823059]
set x2range [0:43.1486210823059]
set x2tics rotate
set ytics
set ylabel 'Value'
set format y "%12.5e"
set size 1, 0.3684
set origin 0, 0.6316
set title 'Orig Data: %pTimeTot = % CPU Usage Total ([User+System]/Wall)'
plot 'procmon_machine_1.txt.dat' index 0 using 1:2 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: %pTimeCur = % CPU Usage Instantaneous ([User+System]/Wall)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.4211
set title 'Orig Data: %pTimeCur = % CPU Usage Instantaneous ([User+System]/Wall)'
plot 'procmon_machine_1.txt.dat' index 0 using 1:3 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: %mMemFree = % Machine Memory Free] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.2105
set title 'Orig Data: %mMemFree = % Machine Memory Free'
plot 'procmon_machine_1.txt.dat' index 0 using 1:4 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: pSize = Process Size (bytes)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.0000
set title 'Orig Data: pSize = Process Size (bytes)'
plot 'procmon_machine_1.txt.dat' index 0 using 1:5 notitle with lines lt 1 lw 3
set nomultiplot
#
# Plotting [Orig Data: pSizeMax = Maximum Process Size Recorded] on a new page.
# 
set multiplot
set nokey
set grid x2tics ytics
set format x ''
set x2tics
set x2label 'Time (secs)'
set format x2 "%17f"
set  xrange [0:43.1486210823059]
set x2range [0:43.1486210823059]
set x2tics rotate
set ytics
set ylabel 'Value'
set format y "%12.5e"
set size 1, 0.3684
set origin 0, 0.6316
set title 'Orig Data: pSizeMax = Maximum Process Size Recorded'
plot 'procmon_machine_1.txt.dat' index 0 using 1:6 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: pRSS = Resident Set Size [process size in RAM] (bytes)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.4211
set title 'Orig Data: pRSS = Resident Set Size [process size in RAM] (bytes)'
plot 'procmon_machine_1.txt.dat' index 0 using 1:7 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: %RSS:pSze = % of Process Size   of RSS] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.2105
set title 'Orig Data: %RSS:pSze = % of Process Size   of RSS'
plot 'procmon_machine_1.txt.dat' index 0 using 1:8 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: %RSS:mMem = % of Machine Memory of RSS] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.0000
set title 'Orig Data: %RSS:mMem = % of Machine Memory of RSS'
plot 'procmon_machine_1.txt.dat' index 0 using 1:9 notitle with lines lt 1 lw 3
set nomultiplot
#
# Plotting [Orig Data: %pLimSize = % of pSize Limit] on a new page.
# 
set multiplot
set nokey
set grid x2tics ytics
set format x ''
set x2tics
set x2label 'Time (secs)'
set format x2 "%17f"
set  xrange [0:43.1486210823059]
set x2range [0:43.1486210823059]
set x2tics rotate
set ytics
set ylabel 'Value'
set format y "%12.5e"
set size 1, 0.3684
set origin 0, 0.6316
set title 'Orig Data: %pLimSize = % of pSize Limit'
plot 'procmon_machine_1.txt.dat' index 0 using 1:10 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: %pLimRSS = % of RSS   Limit] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.4211
set title 'Orig Data: %pLimRSS = % of RSS   Limit'
plot 'procmon_machine_1.txt.dat' index 0 using 1:11 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: %pLimData = % of Data  Limit] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.2105
set title 'Orig Data: %pLimData = % of Data  Limit'
plot 'procmon_machine_1.txt.dat' index 0 using 1:12 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: %pLimStck = % of Stack Limit] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.0000
set title 'Orig Data: %pLimStck = % of Stack Limit'
plot 'procmon_machine_1.txt.dat' index 0 using 1:13 notitle with lines lt 1 lw 3
set nomultiplot
#
# Plotting [Orig Data: pMajFlt = Number of Major Page Faults (disk reads)] on a new page.
# 
set multiplot
set nokey
set grid x2tics ytics
set format x ''
set x2tics
set x2label 'Time (secs)'
set format x2 "%17f"
set  xrange [0:43.1486210823059]
set x2range [0:43.1486210823059]
set x2tics rotate
set ytics
set ylabel 'Value'
set format y "%12.5e"
set size 1, 0.3684
set origin 0, 0.6316
set title 'Orig Data: pMajFlt = Number of Major Page Faults (disk reads)'
plot 'procmon_machine_1.txt.dat' index 0 using 1:14 notitle with lines lt 1 lw 3
#
# Plotting [Orig Data: pMinFlt = Number of Minor Page Faults (no disk reads)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.4211
set title 'Orig Data: pMinFlt = Number of Minor Page Faults (no disk reads)'
plot 'procmon_machine_1.txt.dat' index 0 using 1:15 notitle with lines lt 1 lw 3
set nomultiplot
set nomultiplot
#
# Plotting [computation: delta_t = Time in Block (secs)] on a new page.
# 
set multiplot
set nokey
set grid x2tics ytics
set format x ''
set x2tics
set x2label 'Time (secs)'
set format x2 "%17f"
set  xrange [0:43.1486210823059]
set x2range [0:43.1486210823059]
set x2tics rotate
set ytics
set ylabel 'Value'
set format y "%12.5e"
set size 1, 0.3684
set origin 0, 0.6316
set title 'computation: delta_t = Time in Block (secs)'
plot 'procmon_machine_1.txt.dat' index 1 using 1:3 notitle with linespoints lt 1 
#
# Plotting [computation: delta_m = Change in Memory Size (bytes)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.4211
set title 'computation: delta_m = Change in Memory Size (bytes)'
plot 'procmon_machine_1.txt.dat' index 1 using 1:4 notitle with linespoints lt 1 
#
# Plotting [computation: max_m = Maximum Memory Used (bytes)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.2105
set title 'computation: max_m = Maximum Memory Used (bytes)'
plot 'procmon_machine_1.txt.dat' index 1 using 1:5 notitle with linespoints lt 1 
set nomultiplot
set nomultiplot
#
# Plotting [io: delta_t = Time in Block (secs)] on a new page.
# 
set multiplot
set nokey
set grid x2tics ytics
set format x ''
set x2tics
set x2label 'Time (secs)'
set format x2 "%17f"
set  xrange [0:43.1486210823059]
set x2range [0:43.1486210823059]
set x2tics rotate
set ytics
set ylabel 'Value'
set format y "%12.5e"
set size 1, 0.3684
set origin 0, 0.6316
set title 'io: delta_t = Time in Block (secs)'
plot 'procmon_machine_1.txt.dat' index 2 using 1:3 notitle with linespoints lt 1 
#
# Plotting [io: delta_m = Change in Memory Size (bytes)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.4211
set title 'io: delta_m = Change in Memory Size (bytes)'
plot 'procmon_machine_1.txt.dat' index 2 using 1:4 notitle with linespoints lt 1 
#
# Plotting [io: max_m = Maximum Memory Used (bytes)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.2105
set title 'io: max_m = Maximum Memory Used (bytes)'
plot 'procmon_machine_1.txt.dat' index 2 using 1:5 notitle with linespoints lt 1 
set nomultiplot
set nomultiplot
#
# Plotting [Final Res: delta_t = Time in Block (secs)] on a new page.
# 
set multiplot
set nokey
set grid x2tics ytics
set format x ''
set x2tics
set x2label 'File Number'
set format x2 "%.0f"
set  xrange [0:2]
set x2range [0:2]
set x2tics rotate
set ytics
set ylabel 'Value'
set format y "%12.5e"
set size 1, 0.3684
set origin 0, 0.6316
set title 'Final Res: delta_t = Time in Block (secs)'
plot 'procmon_machine_1.txt.dat' index 3 using 2:3 notitle with impulses lt 1 lw 4 
#
# Plotting [Final Res: delta_m = Change in Memory Size (bytes)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.4211
set title 'Final Res: delta_m = Change in Memory Size (bytes)'
plot 'procmon_machine_1.txt.dat' index 3 using 2:4 notitle with impulses lt 1 lw 4 
#
# Plotting [Final Res: max_m = Maximum Memory Used (bytes)] on the same page.
# 
set x2label ''
set format x2 ""
set size 1, 0.2105
set origin 0, 0.2105
set title 'Final Res: max_m = Maximum Memory Used (bytes)'
plot 'procmon_machine_1.txt.dat' index 3 using 2:5 notitle with impulses lt 1 lw 4 
set nomultiplot
# 
# Print Datafile Key
# 
set title ''
set nogrid
set noborder
set noxtics
set noytics
set nox2tics
set ylabel
set size 1,1
set origin 0,0
set key left Left reverse title 'Datafile Legend' box
plot '-' title 'procmon_machine_1.txt' with lines lt 1
0
e
