MODULE instrument_constants
  ! SIZE: buffer size = SIZE*work_index
  integer(KIND=4), parameter :: SIZE      = 1024*1024*256
  integer(KIND=4), parameter :: NUM_BUFS  = 1024
end MODULE instrument_constants
program heap_f
  use instrument_constants
  IMPLICIT NONE
  integer(KIND=4) :: i
  integer(KIND=KIND(1_8)) :: heap_size
  character(len=50) :: place
  integer :: istat
  type :: char_pointer
     character, dimension(:), pointer :: p
  end type char_pointer
  type (char_pointer), dimension(NUM_BUFS) :: &
       bufs
  do i = 1, NUM_BUFS
     write( place, '(I3,A)' ) i, ACHAR(0)
     call PROCMON_INFO_GET_PRINT( place//ACHAR(0), 0 )
     allocate(bufs(i)%p(1:SIZE), STAT=istat)
     if( istat .ne. 0 ) then
        exit
     endif
     ! bufs(i)%p(:) = '0'
     call PROCMON_INFO_GET_PRINT( place//ACHAR(0), 1 )
     heap_size = SIZE * i
     print*, 'Heap Size: ', heap_size
  enddo
end program heap_f
