#include "procmon_info.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>
/*  A simple instrumentation example - but uses PROCMON_info_settings_get
 *  and PROCMON_info_settings_print to print out data in a form that
 *  procmon_post.pl can be used. */
int main(
         int argc,
         char **argv
         )
{
  PROCMON_INFO_struct pinfo; /* sample data */
  PROCMON_INFO_SETTINGS_struct psettings; /* settings info */
  FILE *output_fd; /* output file */
  /* init pinfo */
  PROCMON_info_init( &pinfo );
  /* using PROCMON_info_settings_get() allows the file name to
   * be defined an various envirment variables (eg PROCMON_DIR) to
   * be used.  You do not have to call PROCMON_info_settings_get or
   * PROCMON_info_settings_print and you can still use procmon_post.pl
   * on the data printed by PROCMON_info_print(). */
  PROCMON_info_settings_get( 0, NULL, &psettings );
  /* open output file and print settings header */
  if( strlen( psettings.outfile_name ) > 0 )
    {
      output_fd = fopen( psettings.outfile_name, "a" );
    }
  else
    {
      output_fd = NULL;
    }
  PROCMON_info_settings_print( &psettings, output_fd );
  /* Timing taken so quickly that funkiness sometimes happens.
   * Wait for successful one and print it */
  while( PROCMON_info_get( 0, &pinfo ) == PROCMON_WARNING ) {}
  PROCMON_info_print( &pinfo, &psettings, output_fd );
  sleep(1); /* simulate "work" */
  while( PROCMON_info_get( 0, &pinfo ) == PROCMON_WARNING ) {}
  PROCMON_info_print( &pinfo, &psettings, output_fd );
  return( 0 );
}
