#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "procmon_info.h"
#define SEC_TIME_SPEC(time) ((time).tv_sec + ((time).tv_nsec)/1000000000.0)
#define SECONDS 3
#define LOOPS 5
#define BUF_SIZE 1024*1024
int main( int argc, char **argv )
{
  char
    *buf; /* buf to write repeatedly to file */
  int
    i; /* loop var */
  struct timespec
    timespec_info; /* from clock_gettime */
  double
    time_diff, /* absolute time */
    time_start; /* start time in secs for the interval */
  FILE
    *io_file_fd; /* file to write io stuff to */
  /* ------------------- */
  /* init file, buf, ... */
  /* ------------------- */
  buf = malloc( BUF_SIZE );
  memset( buf, 1, BUF_SIZE );
  io_file_fd = fopen( "io_file", "w" );
  for( i = 0; i < LOOPS; i++ )
    {
      /* ----------- */
      /* computation */
      /* ----------- */
      printf( " %15s %2d/%2d\n", "Computation", i+1, LOOPS );
      clock_gettime( CLOCK_REALTIME, &timespec_info );
      time_start = SEC_TIME_SPEC( timespec_info );
      time_diff = 0;
      PROCMON_info_get_print( "computation", 0 );
      while( time_diff < SECONDS )
        {
          clock_gettime( CLOCK_REALTIME, &timespec_info );
          time_diff = SEC_TIME_SPEC( timespec_info ) - time_start;
        }
      PROCMON_info_get_print( "computation", 1 );
      /* -------- */
      /* separate */
      /* -------- */
      clock_gettime( CLOCK_REALTIME, &timespec_info );
      time_start = SEC_TIME_SPEC( timespec_info );
      time_diff = 0;
      while( time_diff < 1 )
        {
          clock_gettime( CLOCK_REALTIME, &timespec_info );
          time_diff = SEC_TIME_SPEC( timespec_info ) - time_start;
        }
      /* -- */
      /* io */
      /* -- */
      printf( " %15s %2d/%2d\n", "IO", i+1, LOOPS );
      clock_gettime( CLOCK_REALTIME, &timespec_info );
      time_start = SEC_TIME_SPEC( timespec_info );
      time_diff = 0;
      PROCMON_info_get_print( "io", 0 );
      while( time_diff < SECONDS )
        {
          fwrite( buf, 1, BUF_SIZE, io_file_fd );
          clock_gettime( CLOCK_REALTIME, &timespec_info );
          time_diff = SEC_TIME_SPEC( timespec_info ) - time_start;
        }
      PROCMON_info_get_print( "io", 1 );
      /* -------- */
      /* separate */
      /* -------- */
      clock_gettime( CLOCK_REALTIME, &timespec_info );
      time_start = SEC_TIME_SPEC( timespec_info );
      time_diff = 0;
      while( time_diff < 1 )
        {
          clock_gettime( CLOCK_REALTIME, &timespec_info );
          time_diff = SEC_TIME_SPEC( timespec_info ) - time_start;
        }
    }
  /* ---------- */
  /* free stuff */
  /* ---------- */
  free( buf );
  fclose( io_file_fd );
  return( 0 );
}
