#include <memory.h>
#include <procmon_info.h>
#if defined( _PROCMON_UPS )
#include "ups.h"
#else
#if defined( _PROCMON_SERIAL )
#else
#include "mpi.h"
#endif
#endif
#define MBYTE 1024*1024
#define START 15
#define SIZE 256*MBYTE
typedef struct recur_struct
{
  char a[SIZE];
} recur_struct;
void sub_recur( int level, int i, recur_struct recur )
{
  long long stack_size = 0;
  char place[5];
  sprintf( place, "%3d", i );
  PROCMON_info_get_print( place, 0 );
  stack_size = i * sizeof( recur );
  printf( "%3d/%3d in %15llu\n", i, level, stack_size );
  if( i < level )
    {
      sub_recur( level, i+1, recur );
    }
  PROCMON_info_get_print( place, 1 );
  printf( "%3d/%3d out\n", i, level );  
}
int main( int argc, char **argv )
{
  int i;
  int ierr;
  int numpes;
  int penum;
  recur_struct recur;
#if defined( _PROCMON_UPS )
  ierr = UPS_AA_Init( argc, argv );
  assert( !ierr );
  PROCMON_rld_reset();
  ierr = UPS_CM_Get_penum( &penum );
  assert( !ierr );
#else
#if defined( _PROCMON_SERIAL )
  penum = 0;
#else
  ierr = MPI_Init( &argc, &argv );
  assert( !ierr );
  PROCMON_rld_reset();
  ierr = MPI_Comm_rank( MPI_COMM_WORLD, &penum );
  assert( !ierr );
#endif
#endif
  i = START;
  while( i >= 0 )
    {
      sub_recur( i, 1, recur );
      i++;
    }
  /* terminate */
#if defined( _PROCMON_UPS )
  ierr = UPS_AA_Terminate();
  assert( !ierr );
#else
#if defined( _PROCMON_SERIAL )
  penum = 0;
#else
  ierr = MPI_Finalize();
  assert( !ierr );
#endif
#endif
  return( 0 );
}
