#define MBYTE 1024*1024
#define START 15
#define SIZE 256*MBYTE
module subs
contains
  recursive subroutine sub_recur( level, i, size )
    integer, intent(in) :: level
    integer, intent(in) :: i
    integer(KIND=KIND(1_8)), intent(in) :: size
    integer(KIND=KIND(1_8)) :: stack_size
    character( len=size ) :: recur
    character(len=50) :: place
    stack_size = size
    write( place, '(I3,A)' ) i, ACHAR(0)
    call PROCMON_INFO_GET_PRINT( place//ACHAR(0), 0 )
    ! do not seem to need to init stack space to hit limit
    ! recur(:) = ''
    stack_size = i * size
    print 10, i, level, stack_size
    if( i < level ) then
       call sub_recur( level, i+1, size )
    endif
    call PROCMON_INFO_GET_PRINT( place//ACHAR(0), 1 )
    print 20, i, level
10  format( I3, '/', I3, ' in ', I15 )
20  format( I3, '/', I3, ' out ' )
  end subroutine sub_recur
end module subs
program stack_f
  use subs
  implicit none
#if defined( _PROCMON_UPS )
#include "upsf.h"
#else
#if defined( _PROCMON_SERIAL )
#else
#include "mpif.h"
#endif
#endif
  integer :: i
  integer :: ierr
  integer :: numpes
  integer :: penum
#if defined( _PROCMON_UPS )
  call UPSF_AA_INIT( ierr );
  call PROCMON_RLD_RESET();
  call UPSF_CM_GET_PENUM( penum, ierr );
#else
#if defined( _PROCMON_SERIAL )
  penum = 0;
#else
  call MPI_INIT( ierr )
  call PROCMON_RLD_RESET();
  call MPI_COMM_RANK( MPI_COMM_WORLD, penum, ierr );
#endif
#endif
  i = START
  do
     if( i < 0 ) exit
     call sub_recur(i, 1, SIZE)
     i = i + 1
  enddo
#if defined( _PROCMON_UPS )
  call UPS_AA_TERMINATE( ierr );
#else
#if defined( _PROCMON_SERIAL )
  penum = 0;
#else
  call MPI_FINALIZE( ierr );
#endif
#endif
end program stack_f
