#include "procmon_info.h"
#include "usage_wrapper.h"
#include <string.h>
void USAGE_wrapper(
                   const int *pinfo_print,
                   double    *p_wall,
                   double    *p_time,
                   double    *p_size,
                   int       *ierr
                   )
{
  static PROCMON_INFO_struct pinfo;              /* process info */
  static PROCMON_INFO_SETTINGS_struct psettings; /* environment settings */
  static FILE *output_fd;                        /* output file */
  static int initialized_file = 0;               /* fopen() */
  static int initialized_psettings = 0;          /* PROCMON_info_settings_get() */
  static int initialized_pinfo = 0;              /* PROCMON_info_init() */
  static double p_size_previous = 0;             /* previous p_size */
  /* intialize pinfo */
  if( initialized_pinfo == 0 )
    {
      PROCMON_info_init( &pinfo );
      initialized_pinfo = 1;
    }
  /* initialize psettings */
  if( initialized_psettings == 0 )
    {
      PROCMON_info_settings_get( 0, NULL, &psettings );
      initialized_psettings = 1;
    }
  /* get pinfo */
  while ( (*ierr = PROCMON_info_get( 0, &pinfo )) == PROCMON_WARNING ){};
  p_wall[0] = pinfo.p_wall[0];
  p_wall[1] = pinfo.p_wall[0] - pinfo.p_wall[1];
  p_time[0] = pinfo.p_time[0];
  p_time[1] = pinfo.p_time[0] - pinfo.p_time[1];
  p_size[0] = pinfo.p_size[0];
  p_size[1] = pinfo.p_size[0] - p_size_previous;
  p_size_previous = pinfo.p_size[0];
  /* print pinfo */
  if( *pinfo_print != 0 )
    {
      /* open file and print header */
      if( initialized_file == 0 )
        {
          if( strlen( psettings.outfile_name ) > 0 )
            {
              output_fd = fopen( psettings.outfile_name, "w" );
            }
          else
            {
              output_fd = NULL;
            }
          PROCMON_info_settings_print( &psettings, output_fd );
          initialized_file = 1;
        }
      /* print pinfo */
      PROCMON_info_print( &pinfo, &psettings, output_fd );
    }
  return;
}
void usage_wrapper(
                   const int *pinfo_print,
                   double    *p_wall,
                   double    *p_time,
                   double    *p_size,
                   int       *ierr
                   )
{
  USAGE_wrapper(
                pinfo_print,
                p_wall,
                p_time,
                p_size,
                ierr
                );
}
void usage_wrapper_(
                    const int *pinfo_print,
                    double    *p_wall,
                    double    *p_time,
                    double    *p_size,
                    int       *ierr
                    )
{
  USAGE_wrapper(
                pinfo_print,
                p_wall,
                p_time,
                p_size,
                ierr
                );
}
void usage_wrapper__(
		     const int *pinfo_print,
		     double    *p_wall,
		     double    *p_time,
		     double    *p_size,
		     int       *ierr
		     )
{
  USAGE_wrapper(
                pinfo_print,
                p_wall,
                p_time,
                p_size,
                ierr
                );
}
void USAGE_WRAPPER(
		   const int *pinfo_print,
		   double    *p_wall,
		   double    *p_time,
		   double    *p_size,
		   int       *ierr
		   )
{
  USAGE_wrapper(
                pinfo_print,
                p_wall,
                p_time,
                p_size,
                ierr
                );
}
