/*
 * This code was originally obtained from
 * Brett Kettering(LANL) and Phil Mucci(UTK)
 */
#if !defined( PROCMON_RLD_H )
#define PROCMON_RLD_H
/* ---------------------------------------------- */
/* remove typesafe linkage if compiling under c++ */
/* ---------------------------------------------- */
#ifdef __cplusplus
extern "C"
{
#endif
#if !defined( PROCMON_EXTERN )
#define PROCMON_EXTERN_ON
#define PROCMON_EXTERN extern
#endif /* !defined( PROCMON_EXTERN ) */
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <fcntl.h>
#include <sys/procfs.h>
#include <sys/resource.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <assert.h>
#include <procmon_info.h>
/* ------------- */
/* useful macros */
/* ------------- */
#define PROCMON_MAX( x, y ) (((x) > (y)) ? (x) : (y))
#define PROCMON_MIN( x, y ) (((x) < (y)) ? (x) : (y))
#define PROCMON_TIMEN_TO_DOUBLE(t) \
  ((double)((t).tv_sec) + (double)((t).tv_nsec) / 1000000000.0)
#define PROCMON_TIMEU_TO_DOUBLE(t) \
  ((double)((t).tv_sec) + (double)((t).tv_usec) / 1000000.0)
/* ---------- */
/* prototypes */
/* ---------- */
#if defined( _PROCMON_CC_GCC )
/* ------------------------------------------------------------- */
/* define init/fini routines via attribute as opposed to ld flag */
/* ------------------------------------------------------------- */
void PROCMON_rld_ctor( void ) __attribute__((constructor));
void PROCMON_rld_dtor( void ) __attribute__((destructor));
#else
void PROCMON_rld_ctor(
                      void
                      );
void PROCMON_rld_dtor(
                      void
                      );
#endif
int PROCMON_rld_init(
                     void
                     );
int PROCMON_rld_terminate(
                          void
                          );
/* ---------------------------------------------- */
/* remove typesafe linkage if compiling under c++ */
/* ---------------------------------------------- */
#ifdef __cplusplus
}
#endif
#endif /* !defined( PROCMON_RLD_H ) */
